Package org.apache.commons.math3.ode.nonstiff

# Class EulerFieldIntegrator<T extends RealFieldElement<T>>

java.lang.Object
org.apache.commons.math3.ode.AbstractFieldIntegrator<T>
org.apache.commons.math3.ode.nonstiff.RungeKuttaFieldIntegrator<T>
org.apache.commons.math3.ode.nonstiff.EulerFieldIntegrator<T>

Type Parameters:
  `T` - the type of the field elements

All Implemented Interfaces:
  `FirstOrderFieldIntegrator<T>`, `FieldButcherArrayProvider<T>`

public class EulerFieldIntegrator<T extends RealFieldElement<T>> extends RungeKuttaFieldIntegrator<T>
This class implements a simple Euler integrator for Ordinary Differential Equations.

The Euler algorithm is the simplest one that can be used to integrate ordinary differential equations. It is a simple inversion of the forward difference expression : `f'=(f(t+h)-f(t))/h` which leads to `f(t+h)=f(t)+hf'`. The interpolation scheme used for dense output is the linear scheme already used for integration.

This algorithm looks cheap because it needs only one function evaluation per step. However, as it uses linear estimates, it needs very small steps to achieve high accuracy, and small steps lead to numerical errors and instabilities.

This algorithm is almost never used and has been included in this package only as a comparison reference for more useful integrators.

Since:
  3.6
See Also:
  - `MidpointFieldIntegrator`
  - `ClassicalRungeKuttaFieldIntegrator`
  - `GillFieldIntegrator`
  - `ThreeEighthesFieldIntegrator`
  - `LutherFieldIntegrator`

## Constructor Summary

Constructors
Constructor
Description
`EulerFieldIntegrator(Field<T> field, T step)`
Simple constructor.

## Method Summary

Modifier and Type
Method
Description
`protected org.apache.commons.math3.ode.nonstiff.EulerFieldStepInterpolator<T>`
`createInterpolator(boolean forward, T[][] yDotK, FieldODEStateAndDerivative<T> globalPreviousState, FieldODEStateAndDerivative<T> globalCurrentState, FieldEquationsMapper<T> mapper)`
Create an interpolator.
`T[][]`
`getA()`
Get the internal weights from Butcher array (without the first empty row).
`T[]`
`getB()`
Get the external weights for the high order method from Butcher array.
`T[]`
`getC()`
Get the time steps from Butcher array (without the first zero).

### Methods inherited from class org.apache.commons.math3.ode.nonstiff.RungeKuttaFieldIntegrator

`fraction, integrate, singleStep`

### Methods inherited from class org.apache.commons.math3.ode.AbstractFieldIntegrator

`acceptStep, addEventHandler, addEventHandler, addStepHandler, clearEventHandlers, clearStepHandlers, computeDerivatives, getCurrentSignedStepsize, getCurrentStepStart, getEquations, getEvaluations, getEvaluationsCounter, getEventHandlers, getField, getMaxEvaluations, getName, getStepHandlers, getStepSize, getStepStart, initIntegration, isLastStep, resetOccurred, sanityChecks, setIsLastStep, setMaxEvaluations, setStateInitialized, setStepSize, setStepStart`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### EulerFieldIntegrator

public EulerFieldIntegrator(Field<T> field, T step)
Simple constructor. Build an Euler integrator with the given step.

Parameters:
  `field` - field to which the time and state vector elements belong
  `step` - integration step

## Method Details

### getC

public T[] getC()
Get the time steps from Butcher array (without the first zero).

Returns:
  time steps from Butcher array (without the first zero

### getA

public T[][] getA()
Get the internal weights from Butcher array (without the first empty row).

Returns:
  internal weights from Butcher array (without the first empty row)

### getB

public T[] getB()
Get the external weights for the high order method from Butcher array.

Returns:
  external weights for the high order method from Butcher array

### createInterpolator

protected org.apache.commons.math3.ode.nonstiff.EulerFieldStepInterpolator<T> createInterpolator(boolean forward, T[][] yDotK, FieldODEStateAndDerivative<T> globalPreviousState, FieldODEStateAndDerivative<T> globalCurrentState, FieldEquationsMapper<T> mapper)
Create an interpolator.

Specified by:
  `createInterpolator` in class `RungeKuttaFieldIntegrator<T extends RealFieldElement<T>>`
Parameters:
  `forward` - integration direction indicator
  `yDotK` - slopes at the intermediate points
  `globalPreviousState` - start of the global step
  `globalCurrentState` - end of the global step
  `mapper` - equations mapper for the all equations
Returns:
  external weights for the high order method from Butcher array